abstract class TreeCache
{
    abstract TreeCacheNode newNode(int i,Object o);
    abstract TreeCacheNode retrieveHere(int i);

    private TreeCacheNode first;
    private int count=0;
    
    synchronized void cacheIntern(int id, Object o)
    {
            System.out.println("cache "+id);

        if(0==count)
        {
            first=newNode(id, o);
            count++;
        }
        else
        cache(id,o,first);
    }
    
    final TreeCacheNode retrieveIntern(int i)
    {
        if(0==count)
        {
            TreeCacheNode enclose=retrieveHere(i);
            first=enclose;
            System.exit(1);
            return enclose;
        };
        TreeCacheResult result=findIntern(i);
        if(result.result!=null)return(result.result);
        TreeCacheNode enclose=retrieveHere(i);
        if(result.last.getLabel()>enclose.getLabel())
            result.last.setRight(enclose);
        else result.last.setLeft(enclose); 
        return enclose;

        
    }
    
    final synchronized TreeCacheResult findIntern(int i)
    {
        if(0==count)return null;
        last=null;
        return findIntern(i,first);
    }
    
    TreeCacheNode last;
    
    private TreeCacheResult findIntern(int i, TreeCacheNode pointer)
    {
        if(null==pointer)return new TreeCacheResult(last,null);
        else
        if(pointer.getLabel()==i)return new TreeCacheResult(last,pointer);
        last=pointer;
        if(pointer.getLabel()>i)return findIntern(i,pointer.right);
        else return findIntern(i,pointer.left);
    }
    
    void cache(int id, Object o, TreeCacheNode pointer)
    {
        if(pointer.getLabel()==id)pointer.init(id,o);
        else
        if(pointer.getLabel()>id)
        {
            System.out.print("r");
            if(pointer.getRight()==null)
            {
                pointer.setRight(newNode(id,o));
                count++;
            }
            else cache(id,o,pointer.getRight());
        }
        else
        {
            System.out.print("l");
            if(null==pointer.getLeft())
            {
                pointer.setLeft(newNode(id,o));
                count++;
            }
            else cache(id,o,pointer.getLeft());
        }
    }
}

class TreeCacheResult
{
    TreeCacheNode result;
    TreeCacheNode last;
    TreeCacheResult(TreeCacheNode l, TreeCacheNode r){ result=r;last=l; }
}
